<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\Fm00004000TarefasService;

class Fm00004000TarefasController extends FMCrud
{
    protected $tarefasService;

    use TResponse;

    public function __construct($crudService, $environment, Fm00004000TarefasService $tarefasService)
    {
        parent::__construct($crudService, $environment);
        $this->tarefasService = $tarefasService;
    }

    // INTEGRAÇÃO SM
    public function getContratos(Request $request)
    {
        try {
            $data = $this->tarefasService->getContratos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasGrid()
    {
        try {
            $data = $this->tarefasService->getTarefasGrid();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getClientes()
    {
        try {
            $data = $this->tarefasService->getClientes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTipoLocalTarefa(Request $request)
    {
        try {
            $data = $this->tarefasService->getTipoLocalTarefa($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocal(Request $request)
    {
        try {
            $data = $this->tarefasService->getLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getChecklistTarefa(Request $request)
    {
        try {
            $data = $this->tarefasService->getChecklistTarefa($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensChecklist(Request $request)
    {
        try {
            $data = $this->tarefasService->getItensChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEscopo()
    {
        try {
            $data = $this->tarefasService->getEscopo();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasSelect(Request $request)
    {
        try {
            $data = $this->tarefasService->getTarefasSelect($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // public function getCriterioTarefa(Request $request)
    // {
    //     try {
    //         $data = $this->tarefasService->getCriterioTarefa($request->getParameters());
    //         $this->sendResponse($data, 200);
    //     } catch (\Exception $ex) {
    //         $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
    //     }
    // }

    public function getCriterios(Request $request)
    {
        try {
            $data = $this->tarefasService->getCriterios($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncionario(Request $request)
    {
        try {
            $data = $this->tarefasService->getFuncionario($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSupervisorTarefa(Request $request)
    {
        try {
            $data = $this->tarefasService->getSupervisorTarefa($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertNovaTarefa(Request $request)
    {
        try {
            $data = $this->tarefasService->insertNovaTarefa($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarEdicaoTarefas(Request $request): void
    {
        try {
            $data = $this->tarefasService->salvarEdicaoTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Throwable $e) {
            throw $e;
        }
    }

    public function inativarTarefas(Request $request)
    {
        try {
            $data = $this->tarefasService->inativarTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasSelectAll()
    {
        try {
            $data = $this->tarefasService->getTarefasSelectAll();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosModalTarefas(Request $request)
    {
        try {
            $data = $this->tarefasService->getDadosModalTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
