<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CalendarioFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTarefasCalendario($parametros, $listaOperadores)
    {
        $sql = "SELECT TO_DATE(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHORAAGEND, 
                'Tarefa' || ' - ' || FCM_CHECKLISTAGEND.NMCHECKLISTAGEND AS NOME, TO_DATE( FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHRFINALAGEND,
                FCM_LOCALCLI.DSCORIDLOCAL, MAX(FCM_ATIVIDADE.DSCORIDATIVIDADE) AS CORATIVIDADE, FCM_CHECKLISTAGEND.NRCHECKLISTAGEND AS CODIGO, FCM_LOCALCLI.NMLOCALCLIENTE,
                OPERADOR.NMOPERADOR
                    FROM FCM_CHECKLISTAGEND
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                    JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                    JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                    JOIN OPERADOR
                    ON OPERADOR.CDOPERADOR = FCM_CHECKLISTAGEND.CDOPERADOR
                    WHERE (TRUNC (FCM_CHECKLISTAGEND.DTHORAAGEND) BETWEEN TO_DATE( :PERIODOINICIAL, 'DD/MM/YYYY') 
                    AND DECODE(TO_DATE(:PERIODOFINAL, 'DD/MM/YYYY'), NULL, TO_DATE('31/12/2099', 'DD/MM/YYYY'), TO_DATE(:PERIODOFINAL, 'DD/MM/YYYY')))
                    AND (FCM_LOCALCLI.NRLOCALCLIENTEPAI IN (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
                                                                WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI) OR :NRLOCALCLIENTEPAI IS NULL)
                    AND (FCM_CHECKLISTAGEND.NRLOCALCLIENTE = :NRLOCALCLIENTE OR :NRLOCALCLIENTE IS NULL)
                    AND (FCM_CHECKLISTAGEND.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
                                                                FROM FCM_ATIVIDADECHK
                                                            WHERE FCM_ATIVIDADECHK.NRATIVIDADE = :NRATIVIDADE) OR :NRATIVIDADE IS NULL)
                    AND (FCM_LOCALCLI.NRTIPOLOCALCLI = :NRTIPOLOCALCLI OR :NRTIPOLOCALCLI IS NULL)
                    AND FCM_CHECKLISTAGEND.CDOPERADOR IN ({$listaOperadores}) AND (OPERADOR.CDOPERADOR = :CDOPERADOR OR :CDOPERADOR IS NULL)
                    GROUP BY FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHRFINALAGEND, 
                    FCM_CHECKLISTAGEND.DTHORAAGEND, FCM_LOCALCLI.DSCORIDLOCAL, FCM_LOCALCLI.NMLOCALCLIENTE, OPERADOR.NMOPERADOR
                
                UNION ALL 
                
                SELECT TO_DATE( FCM_GERENCIAMENTOCHK.DTHORAAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHORAAGEND, 
                'Vistoria' || ' - ' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK AS NOME, TO_DATE( FCM_GERENCIAMENTOCHK.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHRFINALAGEND,
                FCM_LOCALCLI.DSCORIDLOCAL, MAX(FCM_ATIVIDADE.DSCORIDATIVIDADE) AS CORATIVIDADE, FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK AS CODIGO, FCM_LOCALCLI.NMLOCALCLIENTE,
                OPERADOR.NMOPERADOR
                    FROM FCM_GERENCIAMENTOCHK
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE
                    JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_GERENCIAMENTOCHK.NRCHECKLIST
                    JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                    JOIN OPERADOR
                    ON OPERADOR.CDOPERADOR = FCM_GERENCIAMENTOCHK.CDOPERADOR
                    WHERE (TRUNC (FCM_GERENCIAMENTOCHK.DTHORAAGEND) BETWEEN TO_DATE( :PERIODOINICIAL, 'DD/MM/YYYY') 
                    AND DECODE(TO_DATE(:PERIODOFINAL, 'DD/MM/YYYY'), NULL, TO_DATE('31/12/2099', 'DD/MM/YYYY'), TO_DATE(:PERIODOFINAL, 'DD/MM/YYYY')))
                    AND (FCM_LOCALCLI.NRLOCALCLIENTEPAI IN (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
                                                                WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI) OR :NRLOCALCLIENTEPAI IS NULL)
                    AND (FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE = :NRLOCALCLIENTE OR :NRLOCALCLIENTE IS NULL)
                    AND (FCM_GERENCIAMENTOCHK.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
                                                                FROM FCM_ATIVIDADECHK
                                                            WHERE FCM_ATIVIDADECHK.NRATIVIDADE = :NRATIVIDADE) OR :NRATIVIDADE IS NULL)
                    AND (FCM_LOCALCLI.NRTIPOLOCALCLI = :NRTIPOLOCALCLI OR :NRTIPOLOCALCLI IS NULL)
                    AND FCM_GERENCIAMENTOCHK.CDOPERADOR IN ({$listaOperadores}) AND (OPERADOR.CDOPERADOR = :CDOPERADOR OR :CDOPERADOR IS NULL)
                    GROUP BY FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.DTHRFINALAGEND, 
                    FCM_GERENCIAMENTOCHK.DTHORAAGEND, FCM_LOCALCLI.DSCORIDLOCAL, FCM_LOCALCLI.NMLOCALCLIENTE, OPERADOR.NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getLocaisCalendario($parametros)
    {

        $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                             FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI, FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                       FROM FCM_LOCALCLI
                       JOIN FCM_TIPOLOCALCLI
                         ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                          WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = :IDTIPOLOCALCLI";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getSetoresCalendario()
    {

        $sql = "SELECT SECTOR.NRSETOR, SECTOR.NMSETOR, SECTOR.IDATIVO, SECTOR.NRORG, SECTOR.DTINCLUSAO,
                    SECTOR.CDOPERINCLUSAO, SECTOR.NRORGINCLUSAO, SECTOR.DTULTATU, SECTOR.CDOPERULTATU,
                    SECTOR.NRORGULTATU, SECTOR.NRFUNCRESPONSAVEL 
                    FROM FCM_SETOR SECTOR";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getAtividadesCalendario()
    {

        $sql = "SELECT NRATIVIDADE, NMATIVIDADE
                  FROM FCM_ATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoDeLocal()
    {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                 FROM FCM_TIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
