<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class EPIsFactory
{
    use TQuery;

    protected $connection;
    
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getEPIs()
    {
        $sql = "SELECT NREPI, NMEPI, IDATIVO, NRORG FROM FCM_EPI"; 
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirEPIs(array $params)
    {
        $sql = "INSERT INTO FCM_EPI (
           NREPI, NMEPI, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO
        ) VALUES (
            :NREPI, :NMEPI, :IDATIVO, :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarEPI(array $params)
    {
        $sql = "UPDATE FCM_EPI
            SET NMEPI            = :NMEPI,
                CDOPERULTATU    = :CDOPERULTATU,
                NRORGULTATU    = :NRORGULTATU,
                DTULTATU         = SYSDATE
            WHERE NREPI = :NREPI";

        $this->connection->executeStatement($sql, $params);
    }
     
    public function excluirEPI($parametro)
    {
        $sql = "DELETE FROM FCM_EPI
                WHERE NREPI IN ($parametro)";

        $this->connection->executeStatement($sql);
    }

}
