<?php

namespace FM\Service;

use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Zeedhi\Framework\Remote\cURLRequest;

class FileServerService
{

    protected $Environment;
    protected $newCode;
    protected $fileServerApiKeys;
    protected $fileServerUrl;

    public function __construct(Environment $Environment, NewCode $newCode, $fileServerApiKeys, $fileServerUrl)
    {
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->fileServerApiKeys = $fileServerApiKeys;
        $this->fileServerUrl = $fileServerUrl;
    }

    public function uploadFiles($params, $customFolder)
    {
        $nrorg = $this->Environment->getNrOrg();
        if (isset($this->fileServerApiKeys[$nrorg])) {
            $key = $this->fileServerApiKeys[$nrorg];
            $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
            $row = array('FILE' => $params);
            $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);
            return $row['FILE'];
        } else {
            throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado.");
        }
    }

    public function deleteFile($path)
    {
        $nrorg = $this->Environment->getNrOrg();
        $key = $this->fileServerApiKeys[$nrorg];
        $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
        $zhFileUploader->deleteFile($path);
    }

    public function uploadFoto($params, $customFolder) {
        if (isset($this->fileServerApiKeys["20"])) {
            $key = $this->fileServerApiKeys["20"];
            $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
        } else {
            throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado."); 
        }
        
        $row = array('FILE' => $params);
        $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);

        return $row['FILE'][0];
    }

    public function downloadFromServer($params)
    {
        header('Content-Type: application/json; charset =utf-8');
        $typeFile = $params['DSTYPE'];
        $url = $params['DSFOTOTAREFAGERCHK'];
        $splitedString = explode("/", $url);
        $lenSplited = count($splitedString);
        $filename = $splitedString[$lenSplited - 1];
        $content = file_get_contents($url);
        $encodedContent = base64_encode($content);
        $encodedContent = 'data:' . $typeFile . ';base64,' . $encodedContent;
        return $encodedContent;
    }

    // public function uploadImages($params)
    // {
    //     if (isset($this->fileServerApiKeys[$this->Environment->getNrOrg()])) {
    //         $key = $this->fileServerApiKeys[$this->Environment->getNrOrg()];
    //         $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
    //         $customFolder = "FOTOS_FMSM";
    //         $row = array('FILE' => $params);
    //         $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);
    //         $paramsFoto = [];
    //         foreach ($row['FILE'] as $file) {
    //             $paramsFoto[] = [
    //                 "NOME" => $file['name'],
    //                 "PATH" => $file['path'],
    //                 "DS" => $this->fileServerUrl . "/files/" . $file["path"],
    //                 "DSTYPE" => $file["type"],
    //                 "QTSIZE" => $file["size"]
    //             ];
    //         }
    //         return $paramsFoto;
    //     } else {
    //         throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado.");
    //     }
    // }
}
