/* eslint-disable*/
import {
    IDictionary, Metadata,
} from '@zeedhi/core';
import {
    FileInput,
} from '@zeedhi/common';

export default class FileUpload {
    public static async buildFileSendObject(file: any) {
        const base64file = await this.toBase64(file);
        return {
            b64File: base64file,
            lastModified: file.lastModified,
            name: file.name,
            size: file.size,
            type: file.type,
            webkitRelativePath: file.webkitRelativePath,
        };
    }

    public static async toBase64(file: any) {
        return new Promise((resolve, reject) => {
            const reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = () => resolve(reader.result);
            reader.onerror = (error) => reject(error);
        });
    }

    public static async converterImagens(name: string) {
        const fileInputObject = Metadata.getInstance<FileInput>(name).value;
        let arquivos: any = [];
        if (fileInputObject && fileInputObject.length > 0) {
            const types: IDictionary = ['image/jpg', 'image/jpeg', 'image/png'];
            const buildFilesPromises = fileInputObject.map((file: any) => {
                if (types.includes(file.type)) {
                    return this.buildFileSendObject(file);
                }
            });
            await Promise.all(buildFilesPromises).then((files: any) => {
                arquivos = files;
            });
        }
        return arquivos;
    }
}
