/* eslint-disable */
import { IDictionary, Http, Metadata, IEventParam, Loader, SimpleDatasource, } from '@zeedhi/core';
import {
    Text, Textarea, Col, CheckboxMultiple, Button,
    Form, FileInput, Modal, ModalService, LoadingService,
    Select,
    SelectMultiple,
    Date,
    Time,
    TextInput,
    IterableComponentRender,
} from '@zeedhi/common';
import FileUpload from '../FileUpload';
import { Utilities } from '@/util/Utilities';
import { IterableCarousel, TekGrid, TekTreeGrid } from '@zeedhi/teknisa-components-common';
import { ZdButton, ZdFrame } from '@zeedhi/vuetify';

export class Fm00005000VistoriasController {
    public hierarquiasController = Loader.getInstance('HierarquiasController');

    public visibilidadeFrameDetalhes = false;

    public visibilidadeTelaPrincipal = true;

    public visibilidade: boolean = true;

    public currentRow: any = {};

    public nomeVistoria: String = '';

    public nrfoto: String = '';

    private modalVisualizar!: Modal;

    private modalAnexo!: Modal;

    private modalInfoDetalhes!: Modal;

    private modalExibirImagens!: Modal;

    private modalAdicionarVistoria!: Modal;

    public NRGERENCIAMENTOCHK: any = '';

    public modalAnexarImagem!: Modal;

    public disableCheckbox = false;

    public readonlyObservacao = false;

    public disableVistoria = false;

    public disableSalvarVistoria = false;

    public disableAnexarFoto = false;

    public icone: string = 'mdi-play-pause';

    public visibilidadeFrameCarrouselImagens = true;

    public visibilidadeFrameAdicionarImagem = false;
    
    // Controle dos modais e visibilidade 
    public async modalVisualizarDados({ row }: any) {
        this.modalVisualizar = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_001_vistorias_detalhes', true);
        this.modalVisualizar.show();
        this.currentRow = row;

        this.bloquearAcoesVistoriaAvaliada();
    }
    public async fecharModalVisualizarDados() {
        await this.modalVisualizar.hide();
        this.modalVisualizar.destroy();
    }

    public async abrirModalAnexo() {
        this.modalAnexo = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_002_modal_abrir_anexo', true);
        this.modalAnexo.show();
    }

    public async fecharModalAnexo() {
        await this.modalAnexo.hide();
        this.modalAnexo.destroy();
    }

    public async abrirModalExibirImagens() {
        this.modalExibirImagens = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_004_exibir_imagens_anexo', true);
        this.modalExibirImagens.show();
    }

    public async fecharModalExibirImagens() {
        await this.modalExibirImagens.hide();
        this.modalExibirImagens.destroy();
    }

    public async abrirModalInfoDetalhes() {
        this.modalInfoDetalhes = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_003_exibir_info_detalhes', true);
        this.modalInfoDetalhes.show();
    }

    public async fecharModalInfoDetalhes() {
        await this.modalInfoDetalhes.hide();
        this.modalInfoDetalhes.destroy();
    }

    public async abrirModalAdicionarVistoria() {
        this.modalAdicionarVistoria?.destroy();
        this.modalAdicionarVistoria = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_002_adicionar_vistoria', true);
        this.modalAdicionarVistoria.show();
    }

    public fecharModalAdicionarVistoria() {
        this.modalAdicionarVistoria.hide();
        this.modalAdicionarVistoria.destroy();
    }

    public invisivel({ component }: any) {
        component.isVisible = false;
    }

    public visualizarDadosGerais({ row }: any) {
        this.visibilidade = false;
        this.currentRow = row;
        this.NRGERENCIAMENTOCHK = row.NRGERENCIAMENTOCHK;
    }

    public exibirImagem({ component }: any) {
        const carrosel = Metadata.getInstance<IterableCarousel>(component.name.split('_')[1]);
        carrosel.iterable.datasource.updateData([]);
        const row = Metadata.getInstance<Col>('LinhaCarrosel');
        const imagens: any = [];
        if (component.value.length) {
            row.isVisible = true;
            component.value.forEach((imagem: any, pos: number) => {
                imagens.push({
                    id: `cliente_${pos}`,
                    src: window.URL.createObjectURL(imagem),
                });
            });
        } else {
            row.isVisible = false;
        }
        carrosel.iterable.datasource.updateData(imagens);
    }

    // ---------- Validações e filtros ----------
    public setFiltroModal({ component }: IEventParam<TekTreeGrid>) {
        component.datasource.setFilter({
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
        });
    }

    public tituloPagina({ component }: any) {
        const tituloModal = this.currentRow.NMGERENCIAMENTOCHK;
        return component.text = tituloModal;
    }


    public linhaEditavel({ row }: IDictionary<any>) {
        return (row.TIPO !== 'Critério' ? false : true);
    }

    public mudaCor({ row }: IDictionary<any>) {
        if (row.IDMARCADO === 'N') {
            return { 'color': 'rgb(255, 0, 0)' };
        }
    }

    public validaObservacoes({ component }: any) {
        if (this.currentRow.IDOBRIGAOBSERVACAO !== 'S') {
            component.clearValidations();
        }
    }

    public setFiltro({ component }: any) {
        component.datasource.dynamicFilter = {
            IDATIVO: [{
                relation: 'AND',
                operation: 'IN',
                value: 'S',
            }],
        };
        component.datasource.get();
    }

    // ---------- Requisições de get e post ----------
    public salvarCriterios({ component }: any) {
        const iterableCards = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades');
        Http.post('/salvarCriterios', {
            CRITERIOS: Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${component.name.split('_')[1]}`).value,
            NRATIVIDADECHK: component.name.split('_')[1],
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
        }).then(() => {
            Utilities.showSuccessMessage();
            iterableCards.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public carregarFotos({ component }: any) {
        const nr = this.currentRow.NRGERENCIAMENTOCHK;
        component.iterable.datasource.setFilter({
            NRGERENCIAMENTOCHK: nr,
        });
    /*
        this.nrfoto = component.iterable.datasource.data;
        LoadingService.show();
        Http.post('/getFotosVistoria', {

        }).then((response: any) => {
            response.data.data.forEach((dados: IDictionary) => {
                component.iterable.datasource.data.push({
                    NRFOTOTAREFAGERCHK: dados.NRFOTOTAREFAGERCHK,
                    DSFOTOTAREFAGERCHK: dados.DSFOTOTAREFAGERCHK,
                });
            });
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    */
    }

    public carregarFotosTarefa({ component }: any) {
        const nr = this.currentRow.NRCHECKLISTAGEND;

        LoadingService.show();
        Http.post('/getFotosTarefas', {
            NRCHECKLISTAGEND: nr
        }).then((response: any) => {
            if (response.data.data.length === 0) {
                component.isVisible = false;
                Metadata.getInstance<Text>('sem-resultado-imagens-tarefas').isVisible = true;
            } else {
                response.data.data.forEach((dados: IDictionary) => {
                    component.iterable.datasource.data.push({
                        NRFOTOTAREFAAGEND: dados.NRFOTOTAREFAAGEND,
                        DSFOTOTAREFAAGEND: dados.DSFOTOTAREFAAGEND,
                    });
                });
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    // Seta as informações no modal Info Detelhes
    public montarInformacoesComplementares() {
        LoadingService.show();
        const nr = this.currentRow.NRCHECKLISTAGEND;
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-itens');
        const observacoes = Metadata.getInstance<Textarea>('observacoes-tarefas');
        const semItens = Metadata.getInstance<Text>('nao-ha-itens');
        let mensagem = ''

        Http.post('/getItensTarefas', {
            NRCHECKLISTAGEND: nr,
        }).then((response: IDictionary) => {
            const dados = response.data.data;

            checkbox.value = dados.filter((elemento: any) => elemento.IDREALIZADO === 'S').map((elemento: any) => elemento.NMTAREFA);
            (checkbox.datasource as SimpleDatasource)!.items = dados.map((elemento: any) => elemento.NMTAREFA);

            if (dados.length > 0) {
                semItens.isVisible = false;
            } else {
                semItens.isVisible = true;
            }

            if (this.currentRow.DSJUSTCANCELAMENTO !== null && dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO} - Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else if (this.currentRow.DSJUSTCANCELAMENTO !== null) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO}`;
            } else if (dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else {
                mensagem = "Não há observações";
            }
            observacoes.value = mensagem;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public montarObservacao(nr: any) {
        const { data } = Metadata.getInstance<IterableComponentRender>('tek-grid-vistorias').datasource;
        const observacoes = Metadata.getInstance<Textarea>('text-area-observation')
        const dados: any = data.find((row: any) => row.NRGERENCIAMENTOCHK === Number(nr));

        if (this.currentRow.IDOBRIGAOBSERVACAO !== 'S') {
            observacoes.clearValidations();
        }

        Metadata.getInstance<Textarea>('text-area-observation').value = (dados.OBS !== null) ? dados.OBS.replaceAll('_', '\n') : '';
    }   

    public async anexarImage() {
        const imagensConvertidas = await FileUpload.converterImagens('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
        const carrousel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-vistorias');
        const carrouselAnexar = Metadata.getInstance<IterableCarousel>('carouselImagesAnexoTask');
        if (imagensConvertidas.length > 0) {
            LoadingService.show();
            Http.post('/anexarFotoVistoria', {
                IMAGEM: imagensConvertidas,
                NRTAREFA: this.currentRow.NRGERENCIAMENTOCHK,
            }).then((response: any) => {
                carrousel.iterable.datasource.get();

                if (response.data === 'success') {
                    const file = Metadata.getInstance<FileInput>('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
                    file.value = [];
                    Utilities.messages('OK', 'Imagens anexadas com sucesso!');
                    this.fecharFrameAdicionarImagens();
                    carrouselAnexar.iterable.datasource.updateData([]);
                } else {
                    Utilities.messages('Error', 'Ocorreu um erro ao salvar as imagens.<br>.Tente novamente.<br><br>Se o problema persistir entre em contato com o suporte.');
                }
            })
            .finally(() => {
                LoadingService.hide();
            });
            
        }
    }

    public async deletImage({component}: any) {
        LoadingService.show('Deletando...');
        const carrosel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-vistorias');
        Http.post('/excluirImagensVistoria', {
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
            NRFOTOTAREFAGERCHK: component.name.split('_')[1],
        }).then(() => {
            carrosel.iterable.datasource.get();
        })
        .catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public abrirFrameAdicionarImagens () {
        this.visibilidadeFrameCarrouselImagens = false;
        this.visibilidadeFrameAdicionarImagem = true;
    }

    public fecharFrameAdicionarImagens () {
        this.visibilidadeFrameCarrouselImagens = true;
        this.visibilidadeFrameAdicionarImagem = false;
    }
    
    public bloquearAcoesVistoriaAvaliada() {
        const situacao = this.currentRow.IDSITUACAOGERCHK.toString();
        if (situacao === 'Avaliado') {
            this.disableCheckbox = true;
            this.disableVistoria = true;
            this.readonlyObservacao = true;
            this.disableSalvarVistoria = true;
            this.disableAnexarFoto = true;
        } else {
            this.disableCheckbox = false;
            this.disableVistoria = false;
            this.readonlyObservacao = false;
            this.disableSalvarVistoria = false;
            this.disableAnexarFoto = false;
        }
    }

    public montarCriterios({ component }: any) {
        this.montarObservacao(this.currentRow.NRGERENCIAMENTOCHK);
        Http.post('/getCriterios', {
            NRATIVIDADECHK: component.name.split('_')[1],
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
        }).then((response: IDictionary) => {
            if (component.datasource instanceof SimpleDatasource) {
                component!.datasource!.items = response.data.map((elemento: any) => elemento.NMCRITERIOTARGERCHK);
                component.value = response.data.filter((elemento: any) => elemento.IDMARCADO === 'S').map((elemento: any) => elemento.NMCRITERIOTARGERCHK);
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);  
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public finalizarVistoria() {
        const form = Metadata.getInstance<Form>('form-observacoes');
        const iterableVistorias = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades');
        const { data } = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades').datasource;
        const atividades = data.map((elemento: any) => elemento.NRATIVIDADECHK);
        const textArea = Metadata.getInstance<Textarea>('text-area-observation');
        let contador = 0;
        let obs = '';

        atividades.forEach((nr: any) => {
            const criterio = Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${nr}`).value;

            if (criterio.length > 0) {
                contador += 1;
                obs = textArea.value;
            } else if (contador === 0) {
                obs = (textArea.value) ? `${textArea.value}__Mensagem automática: Vistoria finalizada sem critérios de não conformidade` : 'Mensagem automática: Vistoria finalizada sem critérios de não conformidade';
            }
        });

        if (Utilities.validateForm(form)) {
            Http.post('/finalizarVistoria', {
                NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
                DSOBSTAREFAGERCHK: obs,
                ATIVIDADES: atividades,
            }).then(() => {
                Utilities.showSuccessMessage();
                iterableVistorias.datasource.get();
                this.fecharModalVisualizarDados();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
                LoadingService.hide();
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public changeTipoDeLocal({ component }: any) {
        const tipoLocal = Metadata.getInstance<Select>('select-tipo-local-vistoria');
        const local = Metadata.getInstance<Select>('select-local-vistoria');

        local.value = null;
        tipoLocal.value = null;
        if (component.value) {
            tipoLocal.disabled = false;
            tipoLocal.datasource.setFilter({
                CDCLIENTE: component.value,
            });
        } else {
            tipoLocal.disabled = true;
            local.disabled = true;
        }
    }

    public changeLocal() {
        const tipoLocal = Metadata.getInstance<Select>('select-tipo-local-vistoria');
        const local = Metadata.getInstance<Select>('select-local-vistoria');
        const checklist = Metadata.getInstance<Select>('select-checklist-vistoria');

        if (tipoLocal.value > 0) {
            local.disabled = false;
            checklist.disabled = false;
            local.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: 'S',
                CDCLIENTE: Metadata.getInstance<Select>('select-cliente-vistoria').value,
            });
            checklist.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: 'S',
            });
        } else {
            local.value = null;
            local.disabled = true;
            checklist.value = null;
            checklist.disabled = true;
        }
    }

    public async changeContratos({ component }: any) {
        const selectContratos = Metadata.getInstance<Select>('select-contrato-vistoria');
        const responsavel = Metadata.getInstance<Select>('select-responsavel-vistoria');

        responsavel.datasource.setFilter({
            NRLOCALCLIENTE: component.value,
        });

        selectContratos.value = null;
        if (component.value > 0) {
            responsavel.disabled = false;
            selectContratos.disabled = false;
            const { selectValue } = component;
            await selectContratos.datasource.setFilter({
                NRESTRUTURAM: selectValue.NRESTRUTURAM,
            });
        } else if (component.value < 1) {
            responsavel.disabled = true;
            selectContratos.disabled = true;
        }

        this.validationsContrato({ component: selectContratos });
    }

    public validationsContrato({ component }: IEventParam<Select>) {
        if (component.datasource.data.length > 0) {
            component.addValidation('required', {});
        } else {
            component.removeValidation('required');
        }
    }

    public changeItensChecklist() {
        const checklist = Metadata.getInstance<Select>('select-checklist-vistoria');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('select-itens-vistoria');
        if (checklist.value > 0) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: checklist.value,
            });
        } else {
            itenschecklist.setValue([]);
            itenschecklist.disabled = true;
        }
    }

    public changeEscopo() {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('select-itens-vistoria');
        const escopo = Metadata.getInstance<Select>('select-escopo-vistoria');

        if (itenschecklist.value > 0) {
            escopo.disabled = false;
        } else {
            escopo.value = null;
            escopo.disabled = true;
        }
    }

    public changeTarefa() {
        const escopo = Metadata.getInstance<SelectMultiple>('select-escopo-vistoria');
        const tarefa = Metadata.getInstance<SelectMultiple>('select-atividade-vistoria');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('select-itens-vistoria');
        if (escopo.value.length > 0) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.setValue([]);
            tarefa.disabled = true;
        }
    }

    public setCriterios() {
        const tarefa = Metadata.getInstance<SelectMultiple>('select-atividade-vistoria');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('select-itens-vistoria');
        const checklist = Metadata.getInstance<Select>('select-checklist-vistoria');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-criterio-vistoria');

        if (tarefa.value.length > 0) {
            checkbox.datasource?.setFilter({
                NRTAREFACHK: tarefa.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            checkbox.datasource?.get();
            checkbox.isVisible = true;
        } else {
            tarefa.setValue([]);
            checkbox.isVisible = false;
        }
    }

    public salvarVistoria() {
        const form = Metadata.getInstance<Form>('form-adicionar-vistoria');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-criterio-vistoria');

        if (Utilities.validateForm(form)) {
            LoadingService.show();
            Http.post('/insertVistoria', {
                NMGERENCIAMENTOCHK: Metadata.getInstance<TextInput>('input-nome-vistoria').value,
                CDCLIENTE: Metadata.getInstance<Select>('select-cliente-vistoria').value,
                NRTIPOLOCALCLI: Metadata.getInstance<Select>('select-tipo-local-vistoria').value,
                NRLOCALCLIENTE: Metadata.getInstance<Select>('select-local-vistoria').value,
                NRSEQCONTRATO: Metadata.getInstance<Select>('select-contrato-vistoria').value,
                NRCHECKLIST: Metadata.getInstance<Select>('select-checklist-vistoria').value,
                NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('select-itens-vistoria').value,
                NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('select-escopo-vistoria').value,
                NRTAREFACHK: Metadata.getInstance<SelectMultiple>('select-atividade-vistoria').value,
                NRCRITERIOTAREFACHK: checkbox.datasource?.data.filter((box: any) => checkbox.value.indexOf(box.NRCRITERIOTAREFACHK) >= 0),
                DATA: Metadata.getInstance<Date>('input-data-vistoria').value,
                HORARIO: Metadata.getInstance<Time>('input-horario-vistoria').value,
                RESPONSAVEL: Metadata.getInstance<Select>('select-responsavel-vistoria').value,
            }).then(() => {
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                // this.fecharModalAdicionarVistoria();
                LoadingService.hide();
            });
        }
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formVistoria_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }
}
